package io.github.palexdev.validationdemo;

import io.github.palexdev.validationdemo.validation.Severity;
import io.github.palexdev.validationdemo.validation2.Constraint;
import io.github.palexdev.validationdemo.validation2.Validator;
import javafx.application.Application;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Region;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

import java.util.List;

public class ValidationTest2 extends Application {

	@Override
	public void start(Stage primaryStage) {
		BorderPane borderPane = new BorderPane();

		VBox errorsContainer = new VBox(10);
		errorsContainer.setAlignment(Pos.TOP_CENTER);
		errorsContainer.setMaxSize(Region.USE_PREF_SIZE, Region.USE_PREF_SIZE);

		TextField field = new TextField();
		field.setPromptText("8 characters minimum");
		field.setMaxSize(Region.USE_PREF_SIZE, Region.USE_PREF_SIZE);

		CheckBox checkBox = new CheckBox("Agree");

		Button button = new Button("Validate");

		VBox container = new VBox(20, errorsContainer, field, checkBox, button);
		container.setAlignment(Pos.CENTER);

		Constraint textLength = Constraint.of(
				Severity.ERROR,
				"Text should be at least 8 characters long!",
				field.textProperty().length().greaterThanOrEqualTo(8)
		);
		Constraint agree = Constraint.of(
				Severity.ERROR,
				"Must agree!",
				checkBox.selectedProperty()
		);
		Validator validator = new Validator()
				.constraint(textLength)
				.constraint(agree);

		// This enables automatic validation
		// The custom property is not needed any more
		/*validator.setOnUpdated((valid, constraints) -> showErrors(errorsContainer, constraints));*/

		button.setOnAction(event -> showErrors(errorsContainer, validator.validate()));

		borderPane.setCenter(container);
		Scene scene = new Scene(borderPane, 800, 800);
		primaryStage.setScene(scene);
		primaryStage.show();
	}

	private void showErrors(VBox errorsContainer, List<Constraint> invalidConstraints) {
		errorsContainer.getChildren().clear();
		invalidConstraints.forEach(constraint -> errorsContainer.getChildren().add(new Label(constraint.getMessage())));
	}
}
