package io.github.palexdev.validationdemo.others;

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;

import java.util.function.BiConsumer;

public class OnChanged<T> extends When<T> {
	private ChangeListener<T> listener;
	private BiConsumer<T, T> action;

	private OnChanged(ObservableValue<T> observableValue) {
		super(observableValue);
	}

	public static <T> OnChanged<T> on(ObservableValue<T> observableValue) {
		return new OnChanged<>(observableValue);
	}

	public OnChanged<T> then(BiConsumer<T, T> action) {
		this.action = action;
		return this;
	}

	public OnChanged<T> listen() {
		listener = (observable, oldValue, newValue) -> action.accept(oldValue, newValue);
		observableValue.addListener(listener);
		whens.put(observableValue, this);
		return this;
	}

	@Override
	protected void dispose() {
		observableValue.removeListener(listener);
		listener = null;
		whens.remove(observableValue);
	}
}
