package io.github.palexdev.validationdemo.others;

import javafx.beans.InvalidationListener;
import javafx.beans.value.ObservableValue;

import java.util.function.Consumer;

public class OnInvalidated<T> extends When<T> {
	private InvalidationListener listener;
	private Consumer<T> action;

	private OnInvalidated(ObservableValue<T> observableValue) {
		super(observableValue);
	}

	public static <T> OnInvalidated<T> on(ObservableValue<T> observableValue) {
		return new OnInvalidated<>(observableValue);
	}

	public OnInvalidated<T> then(Consumer<T> action) {
		this.action = action;
		return this;
	}

	public OnInvalidated<T> listen() {
		listener = invalidated -> action.accept(observableValue.getValue());
		observableValue.addListener(listener);
		whens.put(observableValue, this);
		return this;
	}

	@Override
	protected void dispose() {
		observableValue.removeListener(listener);
		listener = null;
		whens.remove(observableValue);
	}
}
