package io.github.palexdev.validationdemo.others;

import javafx.beans.value.ObservableValue;

import java.util.WeakHashMap;

public abstract class When<T> {
	protected static final WeakHashMap<ObservableValue<?>, When<?>> whens = new WeakHashMap<>();
	protected final ObservableValue<T> observableValue;

	protected When(ObservableValue<T> observableValue) {
		this.observableValue = observableValue;
	}

	protected abstract When<T> listen();
	protected abstract void dispose();

	public static <T> OnInvalidated<T> onInvalidated(ObservableValue<T> observableValue) {
		return OnInvalidated.on(observableValue);
	}

	public static <T> OnChanged<T> onChanged(ObservableValue<T> observableValue) {
		return OnChanged.on(observableValue);
	}

	public static void disposeFor(ObservableValue<?> observableValue) {
		whens.get(observableValue).dispose();
	}
}
