package io.github.palexdev.validationdemo.validation;

import java.util.function.Predicate;

public class  Constraint<T> {
	private Severity severity;
	private String message;
	private Predicate<T> condition;

	Constraint() {}

	public Constraint(Severity severity, String message, Predicate<T> condition) {
		this.severity = severity;
		this.message = message;
		this.condition = condition;
	}

	public static <T> Constraint<T> of(Severity severity, String message, Predicate<T> condition) {
		return new Constraint<>(severity, message, condition);
	}

	public boolean checkOn(T value) {
		return condition.test(value);
	}

	public Severity getSeverity() {
		return severity;
	}

	void setSeverity(Severity severity) {
		this.severity = severity;
	}

	public String getMessage() {
		return message;
	}

	void setMessage(String message) {
		this.message = message;
	}

	public Predicate<T> getCondition() {
		return condition;
	}

	void setCondition(Predicate<T> condition) {
		this.condition = condition;
	}
}
